% Jim Wang
% 9/9/08
%
% taper.m
%
% solve f(x) = 0 via bisection
%
% usage:  sol = taper(x,f,a,b,tol)
%
%       x = domain
%       f = range
%		a = left endpoint
%		b = right endpoint
%		tol = acceptable tolerance for bisection method
%
%		sol = approximate solution
%
% example:  sol = taper(-10:10,(-10:10)^2,-5,5,.01)

function solution = taper(x,f,a,b,tol)     %Assigning the output of bisect as sol

solution = NaN;                          %Sol is nonexistent right now

if f(a)*f(b) > 0,       %If f(a) and f(b) are the same sign

   disp(' ')
   disp('Sorry, but I can not be sure your function changes sign on [a,b]')

   return                           % Returns to invoking function
end

solution =(x(a)+x(b))/2;                        % Assigns solution the midpoint of x(a) and x(b)
sol = find(x>solution,1,'first');               % finds index for solution
count = 1;  % counter to check for infinite loop
while abs(f(sol))>tol && b ~= a+1 && count <=100,  % While f(sol) is greater than the tolerance, do this
    count = count+1;
    if f(a)*f(sol)<0,               % If f(a) and f(sol) are different signs,
        b=sol;                      % then gives b the value of sol
    else                            % Otherwise, that is f(b) and f(sol) are different signs,
        a=sol;                      % gives a the value of sol
    end
    solution =(x(a)+x(b))/2;                    % Assigns solution the midpoint of x(a) and x(b)
    sol = find(x>=solution-tol,1,'first');           % finds index for solution
end    

if count > 100
    disp('infinite loop, ended the loop early, may be inaccurate')
end

solution = x(sol);  % estimated solution